namespace Upsilon.BaseTypes
{
    internal class LuaBoolean : LuaType
    {
        public LuaBoolean(bool value)
        {
            Value = value;
        }

        public override Type Type => Type.Boolean;
        public override object ToCSharpObject()
        {
            return Value;
        }

        public bool Value { get; }

        public static implicit operator bool(LuaBoolean b)
        {
            return b.Value;
        }

        public static implicit operator LuaBoolean(bool b)
        {
            return new LuaBoolean(b);
        }

        public static LuaBoolean operator ! (LuaBoolean n)
        {
            return new LuaBoolean(!n.Value);
        }

        public override string ToString()
        {
            return Value.ToString();
        }
    }
}