using System.Collections.Immutable;
using Upsilon.Binder;

namespace Upsilon.BaseTypes
{
    internal class LuaFunction : LuaType
    {
        public LuaFunction(ImmutableArray<VariableSymbol> parameters, BoundBlockStatement block)
        {
            Parameters = parameters;
            Block = block;
        }

        public override Type Type => Type.Function;
        public override object ToCSharpObject()
        {
            return Block;
        }

        public ImmutableArray<VariableSymbol> Parameters { get; }
        public BoundBlockStatement Block { get; }
    }
}