using System.Globalization;

namespace Upsilon.BaseTypes.Number
{
    internal class NumberDouble : Number
    {
        public double Value { get; }
        protected override bool IsFloat { get; } = true;

        public NumberDouble(double value)
        {
            Value = value;
        }

        public override int GetHashCode()
        {
            return Value.GetHashCode();
        }

        public override string ToString()
        {
            return Value.ToString(CultureInfo.InvariantCulture);
        }

        public static implicit operator double(NumberDouble n)
        {
            return n.Value;
        }

        public override object ToCSharpObject()
        {
            return Value;
        }
    }
}