using System;
using System.Globalization;

namespace Upsilon.BaseTypes.Number
{
    internal class NumberLong : Number
    {
        public long Value { get; }
        protected override bool IsFloat { get; } = false;

        public NumberLong(long val)
        {
            Value = val;
        }

        public override int GetHashCode()
        {
            return Value.GetHashCode();
        }

        public override string ToString()
        {
            return Value.ToString(CultureInfo.InvariantCulture);
        }

        public static implicit operator long(NumberLong n)
        {
            if (n == null)
                return 0;
            return n.Value;
        }

        public override object ToCSharpObject()
        {
            return Value;
        }
    }
}