using Upsilon.BaseTypes;
using Upsilon.Parser;

namespace Upsilon.Binder
{
    public class BoundBinaryExpression : BoundExpression
    {
        public BoundBinaryExpression(BoundBinaryOperator op, BoundExpression leftExpression, BoundExpression rightExpression, Type type)
        {
            Operator = op;
            LeftExpression = leftExpression;
            RightExpression = rightExpression;
            Type = type;
        }

        public override BoundKind Kind => BoundKind.BoundBinaryExpression;
        public override Type Type { get; }

        public BoundBinaryOperator Operator { get; }
        public BoundExpression LeftExpression { get; }
        public BoundExpression RightExpression { get; }
    }
}