using System.Collections.Immutable;
using Upsilon.BaseTypes;

namespace Upsilon.Binder
{
    public class BoundFunctionCallExpression : BoundExpression
    {
        public FunctionVariableSymbol Identifier { get; }
        public ImmutableArray<BoundExpression> Parameters { get; }

        public BoundFunctionCallExpression(FunctionVariableSymbol identifier, ImmutableArray<BoundExpression> parameters)
        {
            Identifier = identifier;
            Parameters = parameters;
        }

        public override BoundKind Kind => BoundKind.BoundFunctionCallExpression;
        public override Type Type => Type.Nil;
    }
}