using System.Collections.Immutable;

namespace Upsilon.Binder
{
    public class BoundFunctionStatement : BoundStatement
    {
        public VariableSymbol Identifier { get; }
        public ImmutableArray<VariableSymbol> Parameters { get; }
        public BoundBlockStatement Block { get; set; }

        public BoundFunctionStatement(VariableSymbol identifier, ImmutableArray<VariableSymbol> parameters,
            BoundBlockStatement block)
        {
            Identifier = identifier;
            Parameters = parameters;
            Block = block;
        }

        public override BoundKind Kind => BoundKind.BoundFunctionStatement;
    }
}