namespace Upsilon.Binder
{
    public class BoundIfStatement : BoundStatement
    {
        public BoundIfStatement(BoundExpressionStatement condition, BoundBlockStatement block)
        {
            Condition = condition;
            Block     = block;
        }

        public BoundIfStatement(BoundExpressionStatement condition, BoundBlockStatement block, BoundElseStatement elseStatement)
        {
            Condition     = condition;
            Block         = block;
            ElseStatement = elseStatement;
        }
        public BoundIfStatement(BoundExpressionStatement condition, BoundBlockStatement block, BoundIfStatement nextElseIf)
        {
            Condition     = condition;
            Block         = block;
            NextElseIf = nextElseIf;
        }

        public override BoundKind Kind => BoundKind.BoundIfStatement;

        public BoundExpressionStatement Condition { get; }
        public BoundBlockStatement Block { get; }
        public BoundIfStatement NextElseIf { get; }
        public BoundElseStatement ElseStatement { get; }
    }

    public class BoundElseStatement : BoundStatement
    {
        public BoundBlockStatement Block { get; }

        public BoundElseStatement(BoundBlockStatement block)
        {
            Block = block;
        }

        public override BoundKind Kind => BoundKind.BoundElseStatement;
    }
}