using System.Collections.Immutable;
using Upsilon.BaseTypes;

namespace Upsilon.Binder
{
    public class VariableSymbol
    {
        public VariableSymbol(string name, Type type, bool local)
        {
            Type = type;
            Local = local;
            Name = name;
        }

        public Type Type { get; set; }
        public bool Local { get; }
        public string Name { get; }
    }

    public class FunctionVariableSymbol : VariableSymbol
    {
        public ImmutableArray<VariableSymbol> Parameters { get; }
        public bool IsBound { get; set; }

        public FunctionVariableSymbol(string name, Type type, bool local, ImmutableArray<VariableSymbol> parameters)
            : base(name, type, local)
        {
            Parameters = parameters;
        }
    }
}