using System.Collections.Generic;

namespace Upsilon.Parser
{
    public class UnaryExpressionSyntax : ExpressionSyntax
    {
        public UnaryExpressionSyntax(SyntaxToken @operator, ExpressionSyntax expression)
        {
            Operator = @operator;
            Expression = expression;
        }

        public override SyntaxKind Kind => SyntaxKind.UnaryExpression;

        public SyntaxToken Operator { get; }
        public ExpressionSyntax Expression { get; }

        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return Operator;
            yield return Expression;
        }
    }
}