using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public sealed class AssignmentExpressionSyntax : StatementSyntax
    {
        public AssignmentExpressionSyntax(SyntaxToken localToken, IdentifierToken identifier, SyntaxToken equalsToken,
            ExpressionSyntax expression)
        {
            LocalToken = localToken;
            Identifier  = identifier;
            EqualsToken = equalsToken;
            Expression  = expression;
            var start = LocalToken?.Span.Start ?? Identifier.Span.Start;
            Span = new TextSpan(start, Expression.Span.End - start);
        }

        public override SyntaxKind Kind => SyntaxKind.AssignmentStatement;

        public SyntaxToken LocalToken { get; }
        public IdentifierToken      Identifier { get; }
        public SyntaxToken EqualsToken { get; }
        public ExpressionSyntax Expression { get; }

        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return Identifier;
            yield return Expression;
        }
    }
}