using System.Collections.Generic;

namespace Upsilon.Parser
{
    public class ReturnStatementSyntax : StatementSyntax
    {
        public ReturnStatementSyntax(SyntaxToken returnToken, ExpressionSyntax expression)
        {
            ReturnToken = returnToken;
            Expression = expression;
        }

        public SyntaxToken ReturnToken { get; }
        public ExpressionSyntax Expression { get; }
        public override SyntaxKind Kind => SyntaxKind.ReturnStatement;
        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return Expression;
        }
    }
}