namespace Upsilon.Parser
{
    public enum SyntaxKind
    {
        // misc
        EndOfFile,
        WhiteSpace,
        BadToken,

        // tokens
        Number,
        Plus,
        Minus,
        Star,
        Slash,
        OpenParenthesis,
        CloseParenthesis,
        Equals,
        EqualsEquals,
        Tilde,
        TildeEquals,
        Comma,
        String,

        // key words
        TrueKeyword,
        FalseKeyword,
        NotKeyword,
        AndKeyword,
        OrKeyword,
        LocalKeyword,
        EndKeyword,
        IfKeyword,
        ThenKeyword,
        ElseIfKeyword,
        ElseKeyword,
        NilKeyword,
        FunctionKeyword,
        ReturnKeyword,

        Identifier,

        // Expressions
        UnaryExpression,
        BinaryExpression,
        LiteralExpression,
        ParenthesizedExpression,
        AssignmentStatement,
        VariableExpression,
        FunctionCallExpression,
        BadExpression,

        // script unit
        ScriptUnit,

        // statements
        ExpressionStatement,
        BlockStatement,
        IfStatement,
        ElseIfStatement,
        ElseStatement,
        FunctionStatement,
        ReturnStatement
    }
}