using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public class SyntaxToken : SyntaxNode
    {
        public SyntaxToken(SyntaxKind kind, int position, string text, object value)
        {
            Kind = kind;
            Span = new TextSpan(position, text.Length);
            Value = value;
        }

        public override SyntaxKind Kind { get; }
        public object Value { get; }

        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield break;
        }
    }
}